Plans
Plan Add Backing
Create a plan to add collateral to a Morpho position
POST
/
accounts
/
{account_id}
/
plan
/
add-backing
Plan Add Backing
curl --request POST \
--url https://api.example.com/accounts/{account_id}/plan/add-backingimport requests
url = "https://api.example.com/accounts/{account_id}/plan/add-backing"
response = requests.post(url)
print(response.text)const options = {method: 'POST'};
fetch('https://api.example.com/accounts/{account_id}/plan/add-backing', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));
Plan Add Backing
Creates a plan to add backing (collateral) to an existing Morpho leveraged position. This improves the position’s health factor without changing leverage. Returns a plan ID and an EIP-712 digest that must be signed to authorize execution.Request
POST /accounts/:account_id/plan/add-backing
Path parameters
| Parameter | Type | Description |
|---|---|---|
account_id | string | The sub-account ID |
Body parameters
| Parameter | Type | Required | Description |
|---|---|---|---|
exposure_asset | string | Yes | The position’s exposure asset (e.g., "WETH") |
backing_asset | string | Yes | The backing/collateral asset (e.g., "USDC") |
market_id | string | Yes | Morpho market ID (0x-prefixed 32-byte hex) |
amount | string | Yes | Amount of backing asset to add in its smallest unit |
is_short | boolean | Yes | true if this is a short position, false for long |
network | string | Yes | Network name (e.g., "base", "mainnet") |
Examples
curl -X POST https://prime-api.legend.xyz/accounts/acc_2o0yiljtp378/plan/add-backing \
-H "Authorization: Bearer $LEGEND_QUERY_KEY" \
-H "Content-Type: application/json" \
-d '{
"exposure_asset": "WETH",
"backing_asset": "USDC",
"market_id": "0xb323495f7e4148be5643a4ea4a8221eef163e4bccfdedc2a6f4696baacbc86cc",
"amount": "1000000000",
"is_short": false,
"network": "base"
}'
const plan = await client.plan.addBacking("acc_2o0yiljtp378", {
exposureAsset: "WETH",
backingAsset: "USDC",
marketId: "0xb323495f7e4148be5643a4ea4a8221eef163e4bccfdedc2a6f4696baacbc86cc",
amount: "1000000000",
isShort: false,
network: "base",
});
plan = await client.plan.add_backing(
"acc_2o0yiljtp378",
exposure_asset="WETH",
backing_asset="USDC",
market_id="0xb323495f7e4148be5643a4ea4a8221eef163e4bccfdedc2a6f4696baacbc86cc",
amount="1000000000",
is_short=False,
network="base",
)
use legend_client::AddBackingParams;
let plan = client.plan.add_backing("acc_2o0yiljtp378", &AddBackingParams {
exposure_asset: "WETH".into(),
backing_asset: "USDC".into(),
market_id: "0xb323495f7e4148be5643a4ea4a8221eef163e4bccfdedc2a6f4696baacbc86cc".into(),
amount: "1000000000".into(),
is_short: false,
network: "base".into(),
}).await?;
Response (201 Created)
{
"plan_id": "pln_71mcui082png",
"details": {
"quark_operation_actions": [...],
"eip712_data": {
"digest": "0x8a3f...b7c2",
"domain_separator": "0x...",
"hash_struct": "0x..."
}
},
"expires_at": "2025-06-15T10:32:00Z"
}
Response fields
| Field | Type | Description |
|---|---|---|
plan_id | string | Unique identifier for this plan (pln_ prefix) |
details | object | Transaction details including EIP-712 signing data |
details.eip712_data.digest | string | The hash to sign with the account’s signer key |
expires_at | string | ISO 8601 timestamp — plan must be executed before this time |
Errors
| Status | Code | Description |
|---|---|---|
| 400 | invalid_params | Missing required parameters or invalid market ID |
| 400 | plan_failed | Could not generate a valid plan |
| 400 | no_wallet | Account has no wallets |
| 408 | timeout | Folio computation timed out |
Notes
- Plans expire after 2 minutes. Sign and execute via Execute Plan before expiry.
- The
market_idmust match the Morpho market of the existing position. - Use Plan Withdraw Backing to remove collateral from a position.
⌘I
Plan Add Backing
